<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="20" :spanTitle="3" title="Regresar" v-on:clickEvent="modalReturnBtn = true" style="margin-bottom:2.5rem"></ReturnButton>
      <el-row :gutter="20">
      <!-- BUSCADOR --> 
        <el-col :span="6" :offset="18">
          <app-search-filter v-model="textSearch"></app-search-filter>
        </el-col>  
      </el-row>
    </header>

   <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <app-title :Title="String(itemSupportMat.originalTitle).toUpperCase()"  bgColor="background-color: #818181 !important"> </app-title>
    </div> 
    
    <section style="margin:0rem 6rem 4rem">
      <el-row style="margin:0 0 1rem 3rem">
        <el-col :span="6">
          <span> Total de Capítulos:  <br></span>                        
        </el-col>
        <el-col :span="12">
          <span>  {{ seasonFilterByTemp.chapters }} <br></span>
        </el-col>
      </el-row> 

      <el-row style="margin:0 0 1rem 3rem">
        <el-col :span="6">
          <span class="text-orange "> Capítulos Registrados: <br></span>                        
        </el-col>
        <el-col :span="12">
          <span class="text-orange "> {{ capRegister }} </span>
        </el-col>
      </el-row> 
      <el-row style="margin:0 0 1rem 3rem">
        <el-col :span="18">
          <h3 style="margin: 3rem 0 2rem"> OBSERVACIONES </h3>
          <el-input
          type="textarea"
          :rows="4"
          v-model="seasonFilterByTemp.observations">
        </el-input>
        </el-col>
      </el-row> 

      <!-- TITULO DE LA TEMPORADA  -->
      <div style="background-color: #fedbcc !important; color: #252525 !important; padding: 8px 20px; margin-top:3rem">
        <h3 class="text-bold"> <span class="bolt" style="margin-left: 10px" > {{ rangesCapsSelected }} </span> </h3> 
      </div>

      <!-- SELECT QUE FILTRA LOS RANGOS DE CAPITULOS  -->
      <div style="margin:3rem 4rem">
        <el-row :gutter="20">
          <el-col :span="6" :offset="18">
            <el-select @change="changeSeason(temporada)" v-model="temporada"  placeholder='rangos de capítulos' style="width: 100%">
              <el-option
              v-for="item in selectItems" 
              :key="item.value"
              :label="item.label"
              :value="item.value">
              </el-option>
            </el-select>  
          </el-col>  
        </el-row>
      </div>



     <!-- CHECKBOX  -->
      <el-row style="margin:4rem 0 1rem 3rem">
        <el-col :span="16" >
          <el-checkbox @change="selectTotalCapCheck(checked)" style="padding: 10px" class="bg-gray bold" size="medium" v-model="checked">Marcar todos los materiales como recibidos.</el-checkbox>
        </el-col>
      </el-row>
    </section>

      <!-- CARDS  -->
       <el-main style="margin:2rem 4rem">
         <el-row :gutter="40">
        <el-col :span="12"  v-for="(item, index) in totalNumbChapter" :key="index">
          <el-collapse class="recept-accordion" style="margin-bottom:3rem">
            <el-collapse-item class="recept-accordion-child">
              <template slot="title">
                <el-row>
                  <el-col :span="20">
                    <div class="recept-accordion-title">
                      <i class="el-icon-caret-right"></i>
                      <div class="box-title">
                        <span class="title-accordion">{{  item.nameCap }}</span>
                      </div>
                    </div>
                    <el-radio-group class="recept-accordion-status" @change="selectOption()" v-model="item.radio">
                      <el-radio label="1">Pendiente</el-radio>
                      <el-radio label="2">Recibido</el-radio>
                    </el-radio-group>
                  </el-col>
                  <el-col :span="4" style="text-align: center; margin-top: 20px;">
                    <img src="../../../assets/images/borrador-rojo.svg" @click="ModalClean(index, item)" >
                    <!-- @click="borrarInfo(index, item)" -->
                  </el-col>
                </el-row>
              </template>
              <div>
                <el-row style="margin: 12px 0px 25px; background: #E0E0E0; padding: 2px 8px; font-size: 15px;">
                  <el-col :span="12"> 
                    <h4 class="text-green"> COPIA DE BACK UP:</h4> 
                  </el-col>     
                  <el-col :span="4">
                    <el-radio v-model="item.copyBackUp" label="SÍ"> SÍ </el-radio>          
                  </el-col> 
                  <el-col :span="4">
                      <el-radio  v-model="item.copyBackUp" label="NO"> NO </el-radio> 
                  </el-col> 
                </el-row>
                <el-row style="margin: 12px 0;" type="flex" align="middle">
                  <el-col :span="6" class="subtitles-chapter-form">
                    Fecha de llegada:
                  </el-col>
                  <el-col :span="14">						
                    <el-date-picker style="width: 100%"
                      v-model="item.arrivalDate" type="date" format="dd/MM/yyyy" value-format="timestamp"  @input="infoMessage">
                    </el-date-picker>
                  </el-col>
                </el-row>
                <el-row style="margin: 12px 0;" type="flex" align="middle">
                  <el-col :span="6" class="subtitles-chapter-form">
                    Modo de envío:
                  </el-col>
                  <el-col :span="14">
                    <app-select v-model="item.shippingMode" :filterArray="modoDeEnvio"  @input="infoMessage"></app-select>
                  </el-col>
                </el-row>
                <el-row style="margin: 12px 0;" type="flex" align="middle">
                  <el-col :span="6" class="subtitles-chapter-form">
                    Soporte:
                  </el-col>
                  <el-col :span="14" >
                    <app-select v-model="item.support" :filterArray="typeSupport"  @input="infoMessage" ></app-select>
                  </el-col>
                </el-row>
                <el-row>
                  <el-col :offset="18" style="margin-top: 2rem">
                    <el-button  @click="eventBtnCopy(item, item.chapter)" size="small" type="primary"> COPIAR</el-button>
                  </el-col>
                </el-row>
              </div>
            </el-collapse-item>
          </el-collapse>
        </el-col>
       </el-row>
      </el-main>

      <section style="margin:5rem 6rem 4rem 6rem">      
        <el-row>
          <el-col :span="2" :offset="17">
            <el-button  size="medium" v-on:click="modalCancelButton = true"  type="primary" plain>CANCELAR </el-button>                          
          </el-col>
          <el-col :span="1" :offset="2">
            <el-button size="medium" @click="enterNewOrder" type="primary"> GUARDAR </el-button>  
          </el-col>
        </el-row>  
      </section>

    <!-- Modal botón copiar-->
     <app-modal :show-dialog.sync="modalCopy" v-if="modalCopy"  nameClass="dialog-orange" :rutImg="require(`../../../assets/images/suspicious.svg`)" sizeImg="80px" textBold="¡Un momento!" typeBtn1="primary"
     :parrafo="'¿Quieres <strong>'+  copy   + '</strong> la informacion en todos los capítulos? ' "
      classBtn1="border-orange" btn1="SI, COPÍAR" btn2="CANCELAR"  @btnEvent="btnCopiar" v-on:eventBtn="modalCopy = false">
    </app-modal>

      <!-- Modal botón ingresar-->
    <AppModalSuccess :show-dialog.sync="enterSupportModal" v-if="enterSupportModal" 
      :parrafo="'Se guardó la información de los capítulos de ' + itemSupportMat.originalTitle"
      btn1="ACEPTAR" @btnEvent="enterSupportModal = false" v-on:btnEvent="returnPage" >
    </AppModalSuccess>

    <!-- Modal botón cancelar -->
    <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton"  v-on:btnEvent="returnPage"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
    </AppModalDanger>

    <!-- Modal botón de retroceder RETURNBUTTON -->
    <AppModalDanger parrafo="Si te vas sin guardar, la información se perderá." :show-dialog.sync="modalReturnBtn" v-if="modalReturnBtn"  v-on:btnEvent="returnPage"  @btnEvent="modalReturnBtn = false" v-on:eventBtn="modalReturnBtn = false">
    </AppModalDanger> 

    <!-- Modal del borrardor -->
    <app-modal :show-dialog.sync="clean" v-if="clean" nameClass="dialog-red" :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="65px" textBold="¡Un momento!"
      :parrafo="'¿Seguro de que quieres borrar la informacion ingresada?'" classBtn1="border-red" typeBtn1="danger" btn1="SÍ, BORRAR" btn2="CANCELAR" @btnEvent="borrarInfo" v-on:eventBtn="clean = false" >
    </app-modal>


  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import Title from '@/components/Title.vue'  
import SearchFilter from '@/components/searchFilter.vue'
import { HTTP } from '../../../main.js' 
import Select from '@/components/AppSelect.vue'
import AppModal from '@/components/AppModal.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import { modifyText } from '../../../utils/modifyText.js'
import { contentTypeSupport } from '@/enums.js'

export default {
  components: {
    ReturnButton,
    AppModalSuccess,
    AppModalDanger,
    'app-search-filter': SearchFilter, 
    'app-title': Title,
    'app-select': Select,
    'app-modal': AppModal
  },
  data() {
    return {
      clean: false,
      modalReturnBtn: false,
      edit: JSON.parse(this.$localStorage.get("edit")), 
      itemStorage: {},
      enterSupportModal: false,
      modalCancelButton: false,
      indexStorage: 0,
      textSearch: '',
      idSupportMat: JSON.parse(this.$localStorage.get("idSupportMat")), 
      itemSupportMat: [],
      season: [],
      selectItems: [],
      textarea3: '',
      checked: false,
      temporada: '',
      seasonFilterByTemp: {},
      radio: '',
      modoDeEnvio: [
        {value: 'Entrega a mano', label: 'Entrega a mano'}    
      ],
      typeSupport: contentTypeSupport,
      modalCopy: false,
      copy: 'copiar',
      indexTemp: 0,
      indexItemCap: 0,
      itemCap: {},
      fusionGourmetSoporte: false,
      rangesCapsSelected : "",
      newArrChaptersRanges: [],
      rangesCapsDefaulChanges: []
    }
  },
  created () {
    this.getSupportMaterials();   
    this.fusionGourmetSoporte = this.$route.params.fusionGourmetSoporte
  },
  computed: {
    totalNumbChapter () {
      let cap = this.rangesCapsDefaulChanges
      if (this.textSearch) {
        cap = this.seasonFilterByTemp.infoByChapter.filter(
          m => modifyText(m.nameCap).indexOf(modifyText(this.textSearch)) > -1)
      }
      return cap       
    }, 
    capRegister() {
      let count = 0
      if(this.seasonFilterByTemp.infoByChapter) {
        this.seasonFilterByTemp.infoByChapter.map((el, i, arr) => {
          if(el.arrivalDate !== '' && el.copyBackUp !== '' && el.shippingMode !== '' && el.support !== '') {
            count += 1 
            this.seasonFilterByTemp.registeredChapters = count          
          }
        })
      }
      return count
    }
  },
  methods: { 
    ModalClean(index, item) {
      this.indexItemCap = index
      this.itemCap = item
      this.clean = true
    },
    enterNewOrder() {
      let revisadoYes = 0
      let revisadoNot = 0 
      let totalCap = 0

    // funcion que contabiliza si todos los capitulos de todas las temporadas han sido llenados
      this.itemSupportMat.numChapters.map((ella, index, arr) => {
      totalCap += Number(ella.chapters)
        ella.infoByChapter.map((el, i, arr) => {

          el.arrivalDateString =  el.arrivalDate == '' ? '' : new Date(el.arrivalDate).toLocaleDateString('en-GB') 
          el.status = false
          el.colorTriangle = false
          if(el.arrivalDate == '' || el.copyBackUp == '' || el.shippingMode == '' || el.support == '') {
            revisadoNot += 1            
          }
          else {
            revisadoYes += 1
          }
        })
      })

      if(revisadoYes === totalCap ) {
        this.itemSupportMat.colorButton = 'success'
        this.itemSupportMat.stateButton = 'COMPLETO'
      }

      else {
        this.itemSupportMat.colorButton = 'danger'
        this.itemSupportMat.stateButton = 'INCOMPLETO'
      }

      let idMat = this.itemSupportMat._id ? this.itemSupportMat._id : this.itemSupportMat.__id

        HTTP.patch(`materials/${ idMat }` , [
        { propName: "stateBtnSupport", value: this.itemSupportMat.stateButton },
        { propName: "numChapters", value: this.itemSupportMat.numChapters },
        { propName: "colorBtnSupport", value: this.itemSupportMat.colorButton }         
        ])
      .then(res => {
        res.data;
        this.enterSupportModal = true
      })
      .catch(err => console.log(err))
    
    },   
    returnPage() {
      if(this.edit === 'edit') {
        if ( this.fusionGourmetSoporte === true ) {
          this.$router.push({ name: 'formProductNac', params: { fusionGourmetSoporte: true } })
        }
        else {
          this.$router.push({ name: 'formProductNac' })
        }        
      }
      else {
        if ( this.fusionGourmetSoporte === true ) {
          this.$router.push({ name: 'fusionGourmetSoporte' })
        }
        else {
          this.$router.push({ name: 'nationalProduction' })
        }         
      }

    },
    getSupportMaterials() {
      this.itemSupportMat =  JSON.parse(sessionStorage.getItem('infoMatSelected'))
      this.season = this.itemSupportMat.numChapters;
      this.seasonFilterByTemp = this.itemSupportMat.numChapters[0]
      this.selectFilterSeason(); 
    },
    // enterProperties() {
    //   this.season.map((el, index, arr) => {
    //     el.seasonString = 'Temporada ' + (index + 1)
    //     this.$set(el, 'reviewed', false)  
    //     this.$set(el, 'registeredChapters', false)

    //     el.infoByChapter.map((ella, i, arr) => {
    //       if(ella.nameCap == undefined) {
    //         this.$set(ella, 'nameCap', 'Capítulo '+ (i + 1)) 
    //         this.$set(ella, 'status', false ) 
    //         this.$set(ella, 'arrivalDate', '') 
    //         this.$set(ella, 'copyBackUp', '') 
    //         this.$set(ella, 'shippingMode', '') 
    //         this.$set(ella, 'support', '' ) 
    //         this.$set(ella, 'radio', '') 
    //         this.$set(ella, 'arrivalDateString', '') 
    //         this.$set(ella, 'colorTriangle', false) 
    //       }
    //     })
    //   })
    // },

    selectFilterSeason() {
      this.selectItems = []
      if ( this.seasonFilterByTemp.infoByChapter.length > 100 ) {
        this.newArrChaptersRanges = []
        let divisionTotalCapAndCapsLimited = (this.seasonFilterByTemp.infoByChapter.length / 100)

        let endLimit = 100
        let startLimit = 0

        for (let i = 0; i < Math.ceil(divisionTotalCapAndCapsLimited); i++) {
          let capsFilter = this.seasonFilterByTemp.infoByChapter.filter( m => {
            return m.chapter <= endLimit && m.chapter > startLimit
          })
          
          let objt = {
            value: i,
            label: 'Capítulos del ' + capsFilter[0].chapter + ' al ' + capsFilter[capsFilter.length -1].chapter
          }

          this.selectItems.push(objt)
          this.newArrChaptersRanges.push(capsFilter)
          endLimit += 100
          startLimit += 100
        }
        this.rangesCapsSelected = this.selectItems[0].label
        this.rangesCapsDefaulChanges = this.newArrChaptersRanges[0]
      }
      else {

        let objt = {
          value: 0,
          label: 'Capítulos del 1 al ' + this.seasonFilterByTemp.infoByChapter.length
        }

        this.selectItems.push(objt)
        this.newArrChaptersRanges.push(this.seasonFilterByTemp.infoByChapter)
        this.rangesCapsSelected = this.selectItems[0].label
        this.rangesCapsDefaulChanges = this.newArrChaptersRanges[0]

      }
    },
    changeSeason(temp) {
      this.rangesCapsDefaulChanges = []
      this.rangesCapsDefaulChanges = this.newArrChaptersRanges[temp]
      this.rangesCapsSelected = this.selectItems[temp].label
      this.indexTemp = temp
    },
    selectTotalCapCheck(checked) {
      if(checked === true) {
        this.seasonFilterByTemp.infoByChapter.map((el, i, arr) => {
        el.radio = '2'
        })
      }
      else {
        this.seasonFilterByTemp.infoByChapter.map((el, i, arr) => {
          el.radio = '1'
        })
      }
    },
    btnCopiar() {
      this.modalCopy = false
      for (let i = this.indexStorage; i < this.seasonFilterByTemp.infoByChapter.length; i ++) {
        this.seasonFilterByTemp.infoByChapter[i].arrivalDate = this.itemStorage.arrivalDate
        this.seasonFilterByTemp.infoByChapter[i].copyBackUp = this.itemStorage.copyBackUp
        this.seasonFilterByTemp.infoByChapter[i].radio = this.itemStorage.radio
        this.seasonFilterByTemp.infoByChapter[i].shippingMode = this.itemStorage.shippingMode
        this.seasonFilterByTemp.infoByChapter[i].support = this.itemStorage.support        
      }
      this.selectOption()
    },
    eventBtnCopy(item, chapter) {
      this.itemStorage = item
      this.indexStorage = chapter-1
      this.modalCopy = true
    },
    borrarInfo( index, item ) {
      this.itemCap.arrivalDate = ''
      this.itemCap.copyBackUp = ''
      this.itemCap.shippingMode = ''
      this.itemCap.support = ''
      this.itemCap.radio = '1'
      this.clean = false
    },
    infoMessage(){
      this.$message('Guardando Información')
    },
    selectOption() {
      let existPend = this.seasonFilterByTemp.infoByChapter.filter(e => e.radio == "1" || e.radio == '').length > 0
      this.checked = !existPend
    }
  }
}
</script>


